import { Injectable } from '@nestjs/common';
import { EntityRepository, EntityManager } from '@mikro-orm/core';
import { InjectRepository } from '@mikro-orm/nestjs';
import { {{pascalCase name}} } from './entities/{{kebabCase name}}.entity';
import { Create{{pascalCase name}}Dto } from './dto/create-{{kebabCase name}}.dto';
import { Update{{pascalCase name}}Dto } from './dto/update-{{kebabCase name}}.dto';

@Injectable()
export class {{pascalCase name}}Repository {
  constructor(
    @InjectRepository({{pascalCase name}})
    private readonly repository: EntityRepository<{{pascalCase name}}>,
    private readonly em: EntityManager,
  ) {}

  async create(create{{pascalCase name}}Dto: Create{{pascalCase name}}Dto): Promise<{{pascalCase name}}> {
    const entity = this.em.create({{pascalCase name}}, create{{pascalCase name}}Dto);
    await this.em.persistAndFlush(entity);
    return entity;
  }

  async findAll(): Promise<{{pascalCase name}}[]> {
    return this.repository.findAll();
  }

  async findOne(id: number): Promise<{{pascalCase name}}> {
    return this.repository.findOne(id);
  }

  async update(id: number, update{{pascalCase name}}Dto: Update{{pascalCase name}}Dto): Promise<{{pascalCase name}}> {
    const entity = await this.repository.findOne(id);
    this.em.assign(entity, update{{pascalCase name}}Dto);
    await this.em.flush();
    return entity;
  }

  async remove(id: number): Promise<void> {
    const entity = await this.repository.findOne(id);
    await this.em.removeAndFlush(entity);
  }
}